<?php
/***************************************************************************
 *                               viewtopic.php
 *                            -------------------
 *   begin                : Saturday, Feb 13, 2001
 *   copyright            : (C) 2001 The phpBB Group
 *   email                : support@phpbb.com
 *
 *   $Id: viewtopic.php,v 1.1 2005/12/28 12:54:44 CK Exp $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
include($phpbb_root_path . 'includes/bbcode.'.$phpEx);
include($phpbb_root_path . 'includes/functions_post.'.$phpEx);


// Cache Posts
// Here you can change the style of the CPS indicators
$CPS_Indicator = array(
	'cached' => '<span style="color: limegreen"><b>&bull;</b></span>',
	'not_cached' => '<span style="color: green"><b>&bull;</b></span>',
	'error' => '<span style="color: red"><b>&bull;</b></span>',
	'dont_cache' => '<span style="color: yellow"><b>&bull;</b></span>',
	'off_but_cached' => '<span style="color: orange"><b>&bull;</b></span>',
	'off' => '<span style="color: black"><b>&bull;</b></span>');
// Cache Posts

//
// Start initial var setup
//
$topic_id = $post_id = 0;
if ( isset($HTTP_GET_VARS[POST_TOPIC_URL]) )
{
        $topic_id = intval($HTTP_GET_VARS[POST_TOPIC_URL]);
}
else if ( isset($HTTP_GET_VARS['topic']) )
{
        $topic_id = intval($HTTP_GET_VARS['topic']);
}

if ( isset($HTTP_GET_VARS[POST_POST_URL]))
{
        $post_id = intval($HTTP_GET_VARS[POST_POST_URL]);
}


$start = ( isset($HTTP_GET_VARS['start']) ) ? intval($HTTP_GET_VARS['start']) : 0;
$start = ($start < 0) ? 0 : $start;

$download = ( isset($HTTP_GET_VARS['download']) ) ? $HTTP_GET_VARS['download'] : '';

if (!$topic_id && !$post_id)
{
        message_die(GENERAL_MESSAGE, 'Topic_post_not_exist');
}
if ( $download )
{
        $sql_download = ( $download != -1 ) ? " AND p.post_id = $download " : '';

        $orig_word = array();
        $replacement_word = array();
        obtain_word_list($orig_word, $replacement_word);

        $sql = "SELECT u.*, p.*,  pt.post_text, pt.post_subject, pt.bbcode_uid
                FROM " . POSTS_TABLE . " p, " . USERS_TABLE . " u, " . POSTS_TEXT_TABLE . " pt
                WHERE p.topic_id = $topic_id
                        $sql_download
                        AND pt.post_id = p.post_id
                        AND u.user_id = p.poster_id
                        ORDER BY p.post_time ASC, p.post_id ASC";
        if ( !($result = $db->sql_query($sql)) )
        {
                message_die(GENERAL_ERROR, "Could not create download stream for post.", '', __LINE__, __FILE__, $sql);
        }

        $download_file = '';
        while ( $row = $db->sql_fetchrow($result) )
        {
                $poster_id = $row['user_id'];
                $poster = ( $poster_id == ANONYMOUS ) ? $lang['Guest'] : $row['username'];

                $post_date = create_date($board_config['default_dateformat'], $row['post_time'], $board_config['board_timezone']);

                $post_subject = ( $row['post_subject'] != '' ) ? $row['post_subject'] : '';

                $bbcode_uid = $row['bbcode_uid'];
                $message = $row['post_text'];
                $message = strip_tags($message);
                $message = preg_replace("/\[.*?:$bbcode_uid:?.*?\]/si", '', $message);
                $message = preg_replace('/\[url\]|\[\/url\]/si', '', $message);
                $message = preg_replace('/\:[0-9a-z\:]+\]/si', ']', $message);

                $message = unprepare_message($message);
                $message = preg_replace('/&#40;/', '(', $message);
                $message = preg_replace('/&#41;/', ')', $message);
                $message = preg_replace('/&#58;/', ':', $message);

                if (count($orig_word))
                {
                        $post_subject = preg_replace($orig_word, $replacement_word, $post_subject);

                        $message = str_replace('\"', '"', substr(@preg_replace('#(\>(((?>([^><]+|(?R)))*)\<))#se', "@preg_replace(\$orig_word, \$replacement_word, '\\0')", '>' . $message . '<'), 1, -1));
                }

                $break = "\n";
                $line = '-----------------------------------';
                $download_file .= $break.$line.$break.$poster.$break.$post_date.$break.$break.$post_subject.$break.$line.$break.$message.$break;
        }

        $disp_folder = ( $download == -1 ) ? 'Topic_'.$topic_id : 'Post_'.$download;
        $filename = $board_config['sitename']."_".$disp_folder."_".date("Ymd",time()).".txt";
        header('Content-Type: text/x-delimtext; name="'.$filename.'"');
        header('Content-Disposition: attachment;filename='.$filename);
        header('Content-Transfer-Encoding: plain/text');
        header('Content-Length: '.strlen($download_file));
        print $download_file;

        exit;
}

//
// Find topic id if user requested a newer
// or older topic
//
if ( isset($HTTP_GET_VARS['view']) && empty($HTTP_GET_VARS[POST_POST_URL]) )
{
        if ( $HTTP_GET_VARS['view'] == 'newest' )
        {
                if ( isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_sid']) || isset($HTTP_GET_VARS['sid']) )
                {
                        $session_id = isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_sid']) ? $HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_sid'] : $HTTP_GET_VARS['sid'];
                                 if (!preg_match('/^[A-Za-z0-9]*$/', $session_id))
                                 {
                                    $session_id = '';
         }

                        if ( $session_id )
                        {
                                $sql = "SELECT p.post_id
                                        FROM " . POSTS_TABLE . " p, " . SESSIONS_TABLE . " s,  " . USERS_TABLE . " u
                                        WHERE s.session_id = '$session_id'
                                                AND u.user_id = s.session_user_id
                                                AND p.topic_id = $topic_id
                                                AND p.post_time >= u.user_lastvisit
                                        ORDER BY p.post_time ASC
                                        LIMIT 1";
                                if ( !($result = $db->sql_query($sql)) )
                                {
                                        message_die(GENERAL_ERROR, 'Could not obtain newer/older topic information', '', __LINE__, __FILE__, $sql);
                                }

                                if ( !($row = $db->sql_fetchrow($result)) )
                                {
                                        message_die(GENERAL_MESSAGE, 'No_new_posts_last_visit');
                                }

                                $post_id = $row['post_id'];

                                if (isset($HTTP_GET_VARS['sid']))
                                {
                                        redirect("viewtopic.$phpEx?sid=$session_id&" . POST_POST_URL . "=$post_id#$post_id");
                                }
                                else
                                {
                                        redirect("viewtopic.$phpEx?" . POST_POST_URL . "=$post_id#$post_id");
                                }
                        }
                }

                redirect(append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id", true));
        }
        else if ( $HTTP_GET_VARS['view'] == 'next' || $HTTP_GET_VARS['view'] == 'previous' )
        {
                $sql_condition = ( $HTTP_GET_VARS['view'] == 'next' ) ? '>' : '<';
                $sql_ordering = ( $HTTP_GET_VARS['view'] == 'next' ) ? 'ASC' : 'DESC';

                $sql = "SELECT t.topic_id
                        FROM " . TOPICS_TABLE . " t, " . TOPICS_TABLE . " t2
                        WHERE
                                t2.topic_id = $topic_id
                                AND t.forum_id = t2.forum_id
                AND t.topic_moved_id = 0
                AND t.topic_last_post_id $sql_condition t2.topic_last_post_id
                        ORDER BY t.topic_last_post_id $sql_ordering
                        LIMIT 1";
                if ( !($result = $db->sql_query($sql)) )
                {
                        message_die(GENERAL_ERROR, "Could not obtain newer/older topic information", '', __LINE__, __FILE__, $sql);
                }

                if ( $row = $db->sql_fetchrow($result) )
                {
                        $topic_id = intval($row['topic_id']);
                }
                else
                {
                        $message = ( $HTTP_GET_VARS['view'] == 'next' ) ? 'No_newer_topics' : 'No_older_topics';
                        message_die(GENERAL_MESSAGE, $message);
                }
        }
}

//
// This rather complex gaggle of code handles querying for topics but
// also allows for direct linking to a post (and the calculation of which
// page the post is on and the correct display of viewtopic)
//
$join_sql_table = (!$post_id) ? '' : ", " . POSTS_TABLE . " p, " . POSTS_TABLE . " p2 ";
$join_sql = (!$post_id) ? "t.topic_id = $topic_id" : "p.post_id = $post_id AND t.topic_id = p.topic_id AND p2.topic_id = p.topic_id AND p2.post_id <= $post_id";
$count_sql = (!$post_id) ? '' : ", COUNT(p2.post_id) AS prev_posts";

$order_sql = (!$post_id) ? '' : "GROUP BY p.post_id, t.topic_id, t.topic_title, t.topic_status, t.topic_replies, t.topic_time, t.topic_type, t.topic_vote, t.topic_last_post_id, t.topic_first_post_id, t.topic_contest, f.forum_name, f.forum_status, f.forum_id, f.auth_view, f.auth_read, f.auth_post, f.auth_reply, f.auth_edit, f.auth_delete, f.auth_sticky, f.auth_announce, f.auth_pollcreate, f.auth_vote, f.auth_attachments, f.auth_contest ORDER BY p.post_id ASC";

$sql = "SELECT t.topic_id, t.topic_title, t.topic_status, t.topic_replies, t.topic_time, t.topic_type, t.topic_vote, t.topic_first_post_id, t.topic_last_post_id, t.topic_cache_lock, t.topic_first_post_id, t.topic_contest, f.forum_name, f.forum_status, f.forum_password, f.forum_id, f.auth_view, f.auth_read, f.auth_post, f.auth_reply, f.auth_edit, f.auth_delete, f.auth_sticky, f.auth_announce, f.auth_pollcreate, f.auth_vote, f.auth_attachments, f.auth_contest" . $count_sql . "
        FROM " . TOPICS_TABLE . " t, " . FORUMS_TABLE . " f" . $join_sql_table . "
        WHERE $join_sql
                AND f.forum_id = t.forum_id
                $order_sql";
attach_setup_viewtopic_auth($order_sql, $sql);

if ( !($result = $db->sql_query($sql)) )
{
        message_die(GENERAL_ERROR, "Could not obtain topic information", '', __LINE__, __FILE__, $sql);
}

if ( !($forum_topic_data = $db->sql_fetchrow($result)) )
{
        message_die(GENERAL_MESSAGE, 'Topic_post_not_exist');
}

$forum_id = intval($forum_topic_data['forum_id']);

//
// Start session management
//
$userdata = session_pagestart($user_ip, $forum_id);
init_userprefs($userdata);
//
// End session management
//

//
// Start auth check
//
$is_auth = array();
$is_auth = auth(AUTH_ALL, $forum_id, $userdata, $forum_topic_data);

if( !$is_auth['auth_view'] || !$is_auth['auth_read'] )
{
        if ( !$userdata['session_logged_in'] )
        {
                $redirect = ($post_id) ? POST_POST_URL . "=$post_id" : POST_TOPIC_URL . "=$topic_id";
                $redirect .= ($start) ? "&start=$start" : '';
                redirect(append_sid("login.$phpEx?redirect=viewtopic.$phpEx&$redirect", true));
        }

        $message = ( !$is_auth['auth_view'] ) ? $lang['Topic_post_not_exist'] : sprintf($lang['Sorry_auth_read'], $is_auth['auth_read_type']);

        message_die(GENERAL_MESSAGE, $message);
}
//
// End auth check
//

$forum_name = $forum_topic_data['forum_name'];
$topic_title = $forum_topic_data['topic_title'];
$topic_id = intval($forum_topic_data['topic_id']);
$topic_time = $forum_topic_data['topic_time'];

//
// Password check
//
if( !$is_auth['auth_mod'] && $userdata['user_level'] != ADMIN )
{
        $redirect = str_replace("&amp;", "&", preg_replace('#.*?([a-z]+?\.' . $phpEx . '.*?)$#i', '\1', htmlspecialchars($HTTP_SERVER_VARS['REQUEST_URI'])));

        if( $HTTP_POST_VARS['cancel'] )
        {
                redirect(append_sid("index.$phpEx"));
        }
        else if( $HTTP_POST_VARS['submit'] )
        {
                if( $forum_topic_data['topic_password'] != '' )
                {
                        password_check('topic', $topic_id, $HTTP_POST_VARS['password'], $redirect);
                }
                else if( $forum_topic_data['forum_password'] != '' )
                {
                        password_check('forum', $forum_id, $HTTP_POST_VARS['password'], $redirect);
                }
        }

        else
        {
        if( $forum_topic_data['topic_password'] != '' )
        {
                $passdata = ( isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_tpass']) ) ? unserialize(stripslashes($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_tpass'])) : '';
                if( $passdata[$topic_id] != md5($forum_topic_data['topic_password']) )
                {
                        password_box('topic', $redirect);
                }
        }
        else if( $forum_topic_data['forum_password'] != '' )
        {
                $passdata = ( isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_fpass']) ) ? unserialize(stripslashes($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_fpass'])) : '';
                if( $passdata[$forum_id] != md5($forum_topic_data['forum_password']) )
                {
                        password_box('forum', $redirect);
                }
        }
        }
}
//
// END: Password check
//

if ($post_id)
{
        $start = floor(($forum_topic_data['prev_posts'] - 1) / intval($board_config['posts_per_page'])) * intval($board_config['posts_per_page']);
}

//
// Is user watching this thread?
//
if( $userdata['session_logged_in'] )
{
        $can_watch_topic = TRUE;

        $sql = "SELECT notify_status
                FROM " . TOPICS_WATCH_TABLE . "
                WHERE topic_id = $topic_id
                        AND user_id = " . $userdata['user_id'];
        if ( !($result = $db->sql_query($sql)) )
        {
                message_die(GENERAL_ERROR, "Could not obtain topic watch information", '', __LINE__, __FILE__, $sql);
        }

        if ( $row = $db->sql_fetchrow($result) )
        {
                if ( isset($HTTP_GET_VARS['unwatch']) )
                {
                        if ( $HTTP_GET_VARS['unwatch'] == 'topic' )
                        {
                                $is_watching_topic = 0;

                                $sql_priority = (SQL_LAYER == "mysql") ? "LOW_PRIORITY" : '';
                                $sql = "DELETE $sql_priority FROM " . TOPICS_WATCH_TABLE . "
                                        WHERE topic_id = $topic_id
                                                AND user_id = " . $userdata['user_id'];
                                if ( !($result = $db->sql_query($sql)) )
                                {
                                        message_die(GENERAL_ERROR, "Could not delete topic watch information", '', __LINE__, __FILE__, $sql);
                                }
                        }

                        $template->assign_vars(array(
                        'GOTO_NEWEST_POST' => '<a href="'.append_sid("viewtopic.$phpEx?t=$topic_id&view=newest").'" class="mainmenu">'.$lang['View_newest_post'].'</a>',
                                'META' => '<meta http-equiv="refresh" content="3;url=' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;start=$start") . '">')
                        );

                        $message = $lang['No_longer_watching'] . '<br /><br />' . sprintf($lang['Click_return_topic'], '<a href="' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;start=$start") . '">', '</a>');
                        message_die(GENERAL_MESSAGE, $message);
                }
                else
                {
                        $is_watching_topic = TRUE;

                        if ( $row['notify_status'] )
                        {
                                $sql_priority = (SQL_LAYER == "mysql") ? "LOW_PRIORITY" : '';
                                $sql = "UPDATE $sql_priority " . TOPICS_WATCH_TABLE . "
                                        SET notify_status = 0
                                        WHERE topic_id = $topic_id
                                                AND user_id = " . $userdata['user_id'];
                                if ( !($result = $db->sql_query($sql)) )
                                {
                                        message_die(GENERAL_ERROR, "Could not update topic watch information", '', __LINE__, __FILE__, $sql);
                                }
                        }
                }
        }
        else
        {
                if ( isset($HTTP_GET_VARS['watch']) )
                {
                        if ( $HTTP_GET_VARS['watch'] == 'topic' )
                        {
                                $is_watching_topic = TRUE;

                                $sql_priority = (SQL_LAYER == "mysql") ? "LOW_PRIORITY" : '';
                                $sql = "INSERT $sql_priority INTO " . TOPICS_WATCH_TABLE . " (user_id, topic_id, notify_status)
                                        VALUES (" . $userdata['user_id'] . ", $topic_id, 0)";
                                if ( !($result = $db->sql_query($sql)) )
                                {
                                        message_die(GENERAL_ERROR, "Could not insert topic watch information", '', __LINE__, __FILE__, $sql);
                                }
                        }

                        $template->assign_vars(array(
                                'META' => '<meta http-equiv="refresh" content="3;url=' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;start=$start") . '">')
                        );

                        $message = $lang['You_are_watching'] . '<br /><br />' . sprintf($lang['Click_return_topic'], '<a href="' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;start=$start") . '">', '</a>');
                        message_die(GENERAL_MESSAGE, $message);
                }
                else
                {
                        $is_watching_topic = 0;
                }
        }
}
else
{
        if ( isset($HTTP_GET_VARS['unwatch']) )
        {
                if ( $HTTP_GET_VARS['unwatch'] == 'topic' )
                {
                        redirect(append_sid("login.$phpEx?redirect=viewtopic.$phpEx&" . POST_TOPIC_URL . "=$topic_id&unwatch=topic", true));
                }
        }
        else
        {
                $can_watch_topic = 0;
                $is_watching_topic = 0;
        }
}

//
// Generate a 'Show posts in previous x days' select box. If the postdays var is POSTed
// then get it's value, find the number of topics with dates newer than it (to properly
// handle pagination) and alter the main query
//
$previous_days = array(0, 1, 7, 14, 30, 90, 180, 364);
$previous_days_text = array($lang['All_Posts'], $lang['1_Day'], $lang['7_Days'], $lang['2_Weeks'], $lang['1_Month'], $lang['3_Months'], $lang['6_Months'], $lang['1_Year']);

if( !empty($HTTP_POST_VARS['postdays']) || !empty($HTTP_GET_VARS['postdays']) )
{
        $post_days = ( !empty($HTTP_POST_VARS['postdays']) ) ? intval($HTTP_POST_VARS['postdays']) : intval($HTTP_GET_VARS['postdays']);
        $min_post_time = time() - (intval($post_days) * 86400);

        $sql = "SELECT COUNT(p.post_id) AS num_posts
                FROM " . TOPICS_TABLE . " t, " . POSTS_TABLE . " p
                WHERE t.topic_id = $topic_id
                        AND p.topic_id = t.topic_id
                        AND p.post_time >= $min_post_time";
        if ( !($result = $db->sql_query($sql)) )
        {
                message_die(GENERAL_ERROR, "Could not obtain limited topics count information", '', __LINE__, __FILE__, $sql);
        }

        $total_replies = ( $row = $db->sql_fetchrow($result) ) ? intval($row['num_posts']) : 0;

        $limit_posts_time = "AND p.post_time >= $min_post_time ";

        if ( !empty($HTTP_POST_VARS['postdays']))
        {
                $start = 0;
        }
}
else
{
        $total_replies = intval($forum_topic_data['topic_replies']) + 1;

        $limit_posts_time = '';
        $post_days = 0;
}

$select_post_days = '<select name="postdays">';
for($i = 0; $i < count($previous_days); $i++)
{
        $selected = ($post_days == $previous_days[$i]) ? ' selected="selected"' : '';
        $select_post_days .= '<option value="' . $previous_days[$i] . '"' . $selected . '>' . $previous_days_text[$i] . '</option>';
}
$select_post_days .= '</select>';

//
// Decide how to order the post display
//
if ( !empty($HTTP_POST_VARS['postorder']) || !empty($HTTP_GET_VARS['postorder']) )
{
        $post_order = (!empty($HTTP_POST_VARS['postorder'])) ? htmlspecialchars($HTTP_POST_VARS['postorder']) : htmlspecialchars($HTTP_GET_VARS['postorder']);
        $post_time_order = ($post_order == "asc") ? "ASC" : "DESC";
}
else
{
        $post_order = 'asc';
        $post_time_order = 'ASC';
}

$select_post_order = '<select name="postorder">';
if ( $post_time_order == 'ASC' )
{
        $select_post_order .= '<option value="asc" selected="selected">' . $lang['Oldest_First'] . '</option><option value="desc">' . $lang['Newest_First'] . '</option>';
}
else
{
        $select_post_order .= '<option value="asc">' . $lang['Oldest_First'] . '</option><option value="desc" selected="selected">' . $lang['Newest_First'] . '</option>';
}
$select_post_order .= '</select>';

//
// Go ahead and pull all data for this topic
//
//MOD-REPLACE: Remove Users Signature & Editing Privileges ----------------------------------------
//added: , u.user_allowsig


$sql = "SELECT u.username, u.user_absence, u.user_absence_mode, u.user_id, u.user_posts, u.user_from, u.user_from_flag, u.user_website, u.user_email, u.user_icq, u.user_aim, u.user_yim, u.user_skype, u.user_regdate, u.user_msnm, u.user_viewemail, u.user_rank, u.user_sig, u.user_sig_bbcode_uid, u.user_avatar, u.user_avatar_type, u.user_allowavatar, u.user_allowsmile, u.ct_miserable_user, u.user_allowsig, u.user_birthday, u.user_next_birthday_greeting, u.user_allow_viewonline, u.user_session_time, p.*, u.user_gender,  pt.post_text, pt.post_subject, pt.bbcode_uid, m.longitude, m.latitude
        FROM " . POSTS_TABLE . " p, " . USERS_TABLE . " u LEFT JOIN " . MAP_MOD_USER_TABLE . " m ON u.user_id=m.user_id, " . POSTS_TEXT_TABLE . " pt
        WHERE p.topic_id = $topic_id
                $limit_posts_time
                AND pt.post_id = p.post_id
                AND u.user_id = p.poster_id
        ORDER BY p.post_time $post_time_order
        LIMIT $start, ".$board_config['posts_per_page'];
if ( !($result = $db->sql_query($sql)) )
{
        message_die(GENERAL_ERROR, "Could not obtain post/user information.", '', __LINE__, __FILE__, $sql);
}

$postrow = array();
if ($row = $db->sql_fetchrow($result))
{
        do
        {
                $postrow[] = $row;
        }
        while ($row = $db->sql_fetchrow($result));
        $db->sql_freeresult($result);

        $total_posts = count($postrow);
}
else
{
   include($phpbb_root_path . 'includes/functions_admin.' . $phpEx);
   sync('topic', $topic_id);

   message_die(GENERAL_MESSAGE, $lang['No_posts_topic']);
}

$resync = FALSE;
if ($forum_topic_data['topic_replies'] + 1 < $start + count($postrow))
{
   $resync = TRUE;
}
elseif ($start + $board_config['posts_per_page'] > $forum_topic_data['topic_replies'])
{
   $row_id = intval($forum_topic_data['topic_replies']) % intval($board_config['posts_per_page']);
   if ($postrow[$row_id]['post_id'] != $forum_topic_data['topic_last_post_id'] || $start + count($postrow) < $forum_topic_data['topic_replies'])
   {
      $resync = TRUE;
   }
}
elseif (count($postrow) < $board_config['posts_per_page'])
{
   $resync = TRUE;
}

if ($resync)
{
   include($phpbb_root_path . 'includes/functions_admin.' . $phpEx);
   sync('topic', $topic_id);

   $result = $db->sql_query('SELECT COUNT(post_id) AS total FROM ' . POSTS_TABLE . ' WHERE topic_id = ' . $topic_id);
   $row = $db->sql_fetchrow($result);
   $total_replies = $row['total'];
}

$sql = "SELECT *
        FROM " . RANKS_TABLE . "
        ORDER BY rank_special, rank_min";
if ( !($result = $db->sql_query($sql)) )
{
        message_die(GENERAL_ERROR, "Could not obtain ranks information.", '', __LINE__, __FILE__, $sql);
}

$ranksrow = array();
while ( $row = $db->sql_fetchrow($result) )
{
        $ranksrow[] = $row;
}
$db->sql_freeresult($result);

//
// Define censored word matches
//
$orig_word = array();
$replacement_word = array();
obtain_word_list($orig_word, $replacement_word);

//
// Censor topic title
//
if ( count($orig_word) )
{
        $topic_title = preg_replace($orig_word, $replacement_word, $topic_title);
}

//
// Word hightlighter with CrackerTracker Protection Engine
// Security System powered by http://www.cback.de
//
$highlight_match = $highlight = '';
if (isset($HTTP_GET_VARS['highlight']))
{
    $highlight = $HTTP_GET_VARS['highlight'];
    $highlight = addslashes($highlight);

    // Split words and phrases
    $words = explode(' ', trim(htmlspecialchars($highlight)));

   for($i = 0; $i < sizeof($words); $i++)
   {
                if (trim($words[$i]) != '')
                {
                        $highlight_match .= (($highlight_match != '') ? '|' : '') . str_replace('*', '\w*', preg_quote($words[$i], '#'));
                }
        }
        unset($words);

        $highlight = urlencode($highlight);
        $highlight_match = phpbb_rtrim($highlight_match, "\\");
}

//
// Post, reply and other URL generation for
// templating vars
//
$new_topic_url = append_sid("posting.$phpEx?mode=newtopic&amp;" . POST_FORUM_URL . "=$forum_id");
$reply_topic_url = append_sid("posting.$phpEx?mode=reply&amp;" . POST_TOPIC_URL . "=$topic_id");
$view_forum_url = append_sid("viewforum.$phpEx?" . POST_FORUM_URL . "=$forum_id");
$view_prev_topic_url = append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;view=previous");
$view_next_topic_url = append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;view=next");

//
// Mozilla navigation bar
//
$nav_links['prev'] = array(
        'url' => $view_prev_topic_url,
        'title' => $lang['View_previous_topic']
);
$nav_links['next'] = array(
        'url' => $view_next_topic_url,
        'title' => $lang['View_next_topic']
);
$nav_links['up'] = array(
        'url' => $view_forum_url,
        'title' => $forum_name
);

$reply_img = ( $forum_topic_data['forum_status'] == FORUM_LOCKED || $forum_topic_data['topic_status'] == TOPIC_LOCKED ) ? $images['reply_locked'] : $images['reply_new'];
$reply_alt = ( $forum_topic_data['forum_status'] == FORUM_LOCKED || $forum_topic_data['topic_status'] == TOPIC_LOCKED ) ? $lang['Topic_locked'] : $lang['Reply_to_topic'];
$post_img = ( $forum_topic_data['forum_status'] == FORUM_LOCKED ) ? $images['post_locked'] : $images['post_new'];
$post_alt = ( $forum_topic_data['forum_status'] == FORUM_LOCKED ) ? $lang['Forum_locked'] : $lang['Post_new_topic'];

//
// Set a cookie for this topic
//
if ( $userdata['session_logged_in'] )
{
        $tracking_topics = ( isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_t']) ) ? unserialize($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_t']) : array();
        $tracking_forums = ( isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_f']) ) ? unserialize($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_f']) : array();

        if ( !empty($tracking_topics[$topic_id]) && !empty($tracking_forums[$forum_id]) )
        {
                $topic_last_read = ( $tracking_topics[$topic_id] > $tracking_forums[$forum_id] ) ? $tracking_topics[$topic_id] : $tracking_forums[$forum_id];
        }
        else if ( !empty($tracking_topics[$topic_id]) || !empty($tracking_forums[$forum_id]) )
        {
                $topic_last_read = ( !empty($tracking_topics[$topic_id]) ) ? $tracking_topics[$topic_id] : $tracking_forums[$forum_id];
        }
        else
        {
                $topic_last_read = $userdata['user_lastvisit'];
        }

        if ( count($tracking_topics) >= 150 && empty($tracking_topics[$topic_id]) )
        {
                asort($tracking_topics);
                unset($tracking_topics[key($tracking_topics)]);
        }

        $tracking_topics[$topic_id] = time();

        setcookie($board_config['cookie_name'] . '_t', serialize($tracking_topics), 0, $board_config['cookie_path'], $board_config['cookie_domain'], $board_config['cookie_secure']);
}

//
// Load templates
//
$template->set_filenames(array(
        'body' => 'viewtopic_body.tpl')
);
// Begin Simple Subforums MOD
$all_forums = array();
make_jumpbox_ref('viewforum.'.$phpEx, $forum_id, $all_forums);

$parent_id = 0;
for( $i = 0; $i < count($all_forums); $i++ )
{
        if( $all_forums[$i]['forum_id'] == $forum_id )
        {
                $parent_id = $all_forums[$i]['forum_parent'];
        }
}

if( $parent_id )
{
        for( $i = 0; $i < count($all_forums); $i++ )
        {
                if( $all_forums[$i]['forum_id'] == $parent_id )
                {
                        $template->assign_vars(array(
                                'PARENT_FORUM'                        => 1,
                                'U_VIEW_PARENT_FORUM'        => append_sid("viewforum.$phpEx?" . POST_FORUM_URL .'=' . $all_forums[$i]['forum_id']),
                                'PARENT_FORUM_NAME'                => $all_forums[$i]['forum_name'],
                                ));
                }
        }
}
// End Simple Subforums MOD



//
// START New Album Pictures
//    by Todd

// ------------------------------------
// Check the user is an admin or moderator to see the unapproved pictures
// ------------------------------------
      if( ($userdata['user_level'] == ADMIN) or ($auth_data['moderator'] == 1) )
      {
         $pic_approval_sql = '';
         $pic_approval_time_sql = '';
      }
      else
      {
      $pic_approval_sql = 'AND pic_approval = 1';
      $pic_approval_time_sql = 'AND pic_approval_time';
      }
//
// END
//


{
   $sql = "SELECT COUNT(pic_id) as total_pics
         FROM ". ALBUM_TABLE ."
                  WHERE pic_time $pic_approval_time_sql >= " . $userdata['user_lastvisit'] ."
    AND pic_user_id != " . $userdata['user_id'];
   $result = $db->sql_query($sql);
   if( $result )
   {
      $picrow = $db->sql_fetchrow($result);
      if( $picrow['total_pics'] == 0 )
      {
         $new_pics = ($lang['No_new_pics'] . '&nbsp;(0)');
      }
      else if( $picrow['total_pics'] == 1 )
      {
         $new_pics = ($lang['New_pic'] . '&nbsp;(1)');
      }
      else
      {
         $new_pics = ($lang['New_pics'] . '&nbsp;' . '(' . $picrow['total_pics'] . ')');
      }
   }
}

//
// END New album pictures
//    by todd
// Some code taken from new picture comment

//
// Output page header
//
$page_title = $lang['View_topic'] .' - ' . $topic_title;
include($phpbb_root_path . 'includes/page_header.'.$phpEx);
//Parse smilies to display topic title
$topic_title = smilies_pass($topic_title);

//
// User authorisation levels output
//
$s_auth_can = ( ( $is_auth['auth_post'] ) ? $lang['Rules_post_can'] : $lang['Rules_post_cannot'] ) . '<br />';
$s_auth_can .= ( ( $is_auth['auth_reply'] ) ? $lang['Rules_reply_can'] : $lang['Rules_reply_cannot'] ) . '<br />';
//MOD-REPLACE: Remove Users Signature & Editing Privileges ----------------------------------------
//added: && $userdata['user_allowedit']
$s_auth_can .= ( ( $is_auth['auth_edit'] && $userdata['user_allowedit'] ) ? $lang['Rules_edit_can'] : $lang['Rules_edit_cannot'] ) . '<br />';
$s_auth_can .= ( ( $is_auth['auth_delete'] ) ? $lang['Rules_delete_can'] : $lang['Rules_delete_cannot'] ) . '<br />';
$s_auth_can .= ( ( $is_auth['auth_vote'] ) ? $lang['Rules_vote_can'] : $lang['Rules_vote_cannot'] ) . '<br />';
attach_build_auth_levels($is_auth, $s_auth_can);


$topic_mod = '';

if ( $is_auth['auth_mod'] )
{
        $s_auth_can .= sprintf($lang['Rules_moderate'], "<a href=modcp.$phpEx?" . POST_FORUM_URL . "=$forum_id&amp;sid=" . $userdata['session_id'] . '>', '</a>');

        $topic_mod .= "<a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=delete&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['topic_mod_delete'] . '" alt="' . $lang['Delete_topic'] . '" title="' . $lang['Delete_topic'] . '" border="0" /></a>&nbsp;';

        $topic_mod .= ( $forum_topic_data['topic_type'] != 1 ) ? "<a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=sticky&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['topic_mod_sticky'] . '" alt="' . $lang['Sticky_topic'] . '" title="' . $lang['Sticky_topic'] . '" border="0" /></a>&nbsp;' : "<a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=unsticky&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['topic_mod_unsticky'] . '" alt="' . $lang['Unsticky_topic'] . '" title="' . $lang['Unsticky_topic'] . '" border="0" /></a>&nbsp;';

        $topic_mod .= ( $forum_topic_data['topic_type'] != 2 ) ? "<a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=announce&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['topic_mod_announce'] . '" alt="' . $lang['Announce_topic'] . '" title="' . $lang['Announce_topic'] . '" border="0" /></a>&nbsp;' : "<a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=unannounce&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['topic_mod_unannounce'] . '" alt="' . $lang['Unannounce_topic'] . '" title="' . $lang['Unannounce_topic'] . '" border="0" /></a>&nbsp;';

        $topic_mod .= "<a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=move&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['topic_mod_move'] . '" alt="' . $lang['Move_topic'] . '" title="' . $lang['Move_topic'] . '" border="0" /></a>&nbsp;';

        $topic_mod .= ( $forum_topic_data['topic_status'] == TOPIC_UNLOCKED ) ? "<a id=\"topic_locklink\" onclick=\"return AJAXLockTopic($topic_id, 1);\" href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=lock&amp;sid=" . $userdata['session_id'] . '"><img id="topic_lockimg" src="' . $images['topic_mod_lock'] . '" alt="' . $lang['Lock_topic'] . '" title="' . $lang['Lock_topic'] . '" border="0" /></a>&nbsp;' : "<a id=\"topic_locklink\" onclick=\"return AJAXLockTopic($topic_id, 0);\" href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=unlock&amp;sid=" . $userdata['session_id'] . '"><img id="topic_lockimg" src="' . $images['topic_mod_unlock'] . '" alt="' . $lang['Unlock_topic'] . '" title="' . $lang['Unlock_topic'] . '" border="0" /></a>&nbsp;';

        $topic_mod .= "<a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=split&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['topic_mod_split'] . '" alt="' . $lang['Split_topic'] . '" title="' . $lang['Split_topic'] . '" border="0" /></a>&nbsp;';
        include_once($phpbb_root_path . 'includes/functions_admin.'.$phpEx);
        $make_move_select = make_forum_select($topic_id.'_new_forum', $forum_id);
        if (strpos($make_move_select, '<select') !== false)
        {
                $topic_mod .= "<div id=\"move_topic\" style=\"display:none\" class=\"gen\"><hr /><b>".$lang['Move'].":</b> ".$make_move_select;
                $topic_mod .= "<br /><input type=\"checkbox\" id=\"shadow\" />&nbsp;" . $lang['Leave_shadow_topic'];
                $topic_mod .= "<hr /><input type=\"button\" value=\"".$lang['Move']."\" onclick=\"return AJAXTopicMove($topic_id, $forum_id);\" />";
                $topic_mod .= "&nbsp;<input type=\"button\" value=\"".$lang['Reset']."\" onclick=\"return AJAXTopicMoveCancel();\" /></div>";
        }
}

//
// Topic watch information
//
$s_watching_topic = '';
if ( $can_watch_topic )
{
        if ( $is_watching_topic )
        {
                $s_watching_topic = "<a id=\"watchlink\" onclick=\"return AJAXWatchTopic($topic_id, $start, 0);\" href=\"viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;unwatch=topic&amp;start=$start&amp;sid=" . $userdata['session_id'] . '">' . $lang['Stop_watching_topic'] . '</a>';
                $s_watching_topic_img = ( isset($images['topic_un_watch']) ) ? "<a id=\"watchlink_img\" onclick=\"return AJAXWatchTopic($topic_id, $start, 0);\" href=\"viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;unwatch=topic&amp;start=$start&amp;sid=" . $userdata['session_id'] . '"><img id="watchimage" src="' . $images['topic_un_watch'] . '" alt="' . $lang['Stop_watching_topic'] . '" title="' . $lang['Stop_watching_topic'] . '" border="0"></a>' : '';
        }
        else
        {
                $s_watching_topic = "<a id=\"watchlink\" onclick=\"return AJAXWatchTopic($topic_id, $start, 1);\" href=\"viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;watch=topic&amp;start=$start&amp;sid=" . $userdata['session_id'] . '">' . $lang['Start_watching_topic'] . '</a>';
                $s_watching_topic_img = ( isset($images['Topic_watch']) ) ? "<a id=\"watchlink_img\" onclick=\"return AJAXWatchTopic($topic_id, $start, 1);\" href=\"viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;watch=topic&amp;start=$start&amp;sid=" . $userdata['session_id'] . '"><img id="watchimage" src="' . $images['Topic_watch'] . '" alt="' . $lang['Start_watching_topic'] . '" title="' . $lang['Start_watching_topic'] . '" border="0"></a>' : '';
        }
}
//
// Add Email topic to friend
//
$s_email_topic = '';
if($userdata['session_logged_in'])
{
        $action = ($post_id) ? POST_POST_URL . "=$post_id" : POST_TOPIC_URL . "=$topic_id&amp;start=$start";
        $s_email_topic = '<a href="' . append_sid("emailtopic.$phpEx?$action") . '">' . $lang['Email_topic'] . '</a>';
}
//
// If we've got a hightlight set pass it on to pagination,
// I get annoyed when I lose my highlight after the first page.
//
$pagination = ( $highlight != '' ) ? generate_pagination("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;postdays=$post_days&amp;postorder=$post_order&amp;highlight=$highlight", $total_replies, $board_config['posts_per_page'], $start) : generate_pagination("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;postdays=$post_days&amp;postorder=$post_order", $total_replies, $board_config['posts_per_page'], $start);
// Cache Posts
if ($board_config['enable_post_cache'])
{
	$cps_topic_img = '<a href="modcp.'.$phpEx.'?'.POST_CPS_MANAGE_URL.'=recycle_topic&amp;'.POST_TOPIC_URL.'='.$topic_id.'&amp;sid='.$userdata['session_id'].'"><img src="'.$images['icon_cache_recycle_topic'].'" alt="'.$lang['CPS_recycle_topic'].'" title="'.$lang['CPS_recycle_topic'].'" border="0" /></a>&nbsp;';
	$cps_topic_img .= ( !$forum_topic_data['topic_cache_lock'] ) ? '<a href="modcp.'.$phpEx.'?'.POST_CPS_MANAGE_URL.'=deactivate_topic&amp;'.POST_TOPIC_URL.'='.$topic_id.'&amp;sid='.$userdata['session_id'].'"><img src="'.$images['icon_cache_deactivate_topic'].'" alt="'.$lang['CPS_dont_cache_topic'].'" title="'.$lang['CPS_dont_cache_topic'].'" border="0" /></a>&nbsp;' : '';
}
else
{
	$cps_topic_img = ($userdata['user_level'] == ADMIN) ? '<a href="modcp.'.$phpEx.'?'.POST_CPS_MANAGE_URL.'=delete_topic&amp;'.POST_TOPIC_URL.'='.$topic_id.'&amp;sid='.$userdata['session_id'].'"><img src="'.$images['icon_cache_delete_topic'].'" alt="'.$lang['CPS_delete_topic'].'" title="'.$lang['CPS_delete_topic'].'" border="0" /></a>&nbsp;' : '';
}
// Cache Posts

//
// Send vars to template
//
$template->assign_vars(array(
        'U_YOUR_PERSONAL_GALLERY' => append_sid("album.$phpEx?user_id=". $userdata['user_id']),
        'L_YOUR_PERSONAL_GALLERY' => $lang['Your_Personal_Gallery'],
        'L_DOWNLOAD_POST' => $lang['Download_post'],
        'L_DOWNLOAD_TOPIC' => $lang['Download_topic'],
        'DOWNLOAD_TOPIC' => append_sid("viewtopic.$phpEx?download=-1&amp;".POST_TOPIC_URL."=".$topic_id),
        'FORUM_ID' => $forum_id,
    'FORUM_NAME' => $forum_name,
    'TOPIC_ID' => $topic_id,
    'TOPIC_TITLE' => $topic_title,
        'PAGINATION' => $pagination,
        'PAGE_NUMBER' => sprintf($lang['Page_of'], ( floor( $start / intval($board_config['posts_per_page']) ) + 1 ), ceil( $total_replies / intval($board_config['posts_per_page']) )),
        'HIGHLIGHT' => $highlight,
        'POST_IMG' => $post_img,
        'REPLY_IMG' => $reply_img,

    'L_PRINT' => ($lang['Print_View']) ? $lang['Print_View'] : 'Printable version',
    'U_PRINT' => append_sid("printview.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;start=$start"),

        'L_AUTHOR' => $lang['Author'],
        'L_MESSAGE' => $lang['Message'],
        'L_POSTED' => $lang['Posted'],
        'L_POST_SUBJECT' => $lang['Post_subject'],
        'L_VIEW_NEXT_TOPIC' => $lang['View_next_topic'],
        'L_VIEW_PREVIOUS_TOPIC' => $lang['View_previous_topic'],
        'L_POST_NEW_TOPIC' => $post_alt,
        'L_POST_REPLY_TOPIC' => $reply_alt,
        'L_BACK_TO_TOP' => $lang['Back_to_top'],
        'L_DISPLAY_POSTS' => $lang['Display_posts'],
        'L_LOCK_TOPIC' => $lang['Lock_topic'],
        'L_UNLOCK_TOPIC' => $lang['Unlock_topic'],
        'L_MOVE_TOPIC' => $lang['Move_topic'],
        'L_SPLIT_TOPIC' => $lang['Split_topic'],
        'L_DELETE_TOPIC' => $lang['Delete_topic'],
        'L_GOTO_PAGE' => $lang['Goto_page'],
        'L_FULL_EDIT' => $lang['Full_edit'],
        'L_PREVIEW' => $lang['Preview'],

        'L_SAVE_CHANGES' => $lang['Save_changes'],
        'L_CANCEL' => $lang['Cancel'],
    'L_ORION_AUTH' => $lang['orion_autho'],

        'S_TOPIC_LINK' => POST_TOPIC_URL,
        'S_SELECT_POST_DAYS' => $select_post_days,
        'S_SELECT_POST_ORDER' => $select_post_order,
        'S_POST_DAYS_ACTION' => append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . '=' . $topic_id . "&amp;start=$start"),
        'S_AUTH_LIST' => $s_auth_can,
        'S_TOPIC_ADMIN' => $topic_mod,
// Cache Posts
	'S_CPS_IMG_TOPIC' => ( $is_auth['auth_mod'] && $board_config['allow_cache_moderate'] || $userdata['user_level'] == ADMIN ) ? $cps_topic_img : '',
// Cache Posts

        'S_EMAIL_TOPIC' => $s_email_topic,
        'S_WATCH_TOPIC' => $s_watching_topic,
        'S_WATCH_TOPIC_IMG' => $s_watching_topic_img,
        'S_DISPLAY_PREVIEW' => 'style="display:none;"',
        'U_FAV' => append_sid("favorites.$phpEx?t=" . $topic_id . "&mode=add"),
'L_FAV' => $lang['add_fav'],
    'U_VIEW_TOPIC' => append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;start=$start&amp;postdays=$post_days&amp;postorder=$post_order&amp;highlight=$highlight"),
        'U_VIEW_FORUM' => $view_forum_url,
        'U_VIEW_OLDER_TOPIC' => $view_prev_topic_url,
        'U_VIEW_NEWER_TOPIC' => $view_next_topic_url,
        'U_POST_NEW_TOPIC' => $new_topic_url,
        // New Album Pictures -   by Todd
    'L_NEW_PICS' => $new_pics,
    'L_PICS' => $lang['Pics'],
    'L_NO_NEW_PICS' => $lang['No_new_pics'],
    'U_NEW_PICS' => append_sid("album_new_pics.$phpEx"),
        'U_POST_REPLY_TOPIC' => $reply_topic_url)
);

//
// Does this topic contain a poll?
//
if (empty($forum_topic_data['topic_vote']))
{
        $template->assign_vars(array(
                'MAX_POLL_OPTION' => 0,
                'MAX_VOTE' => 0)
        );
}
else
if ( !empty($forum_topic_data['topic_vote']) )
{
        $s_hidden_fields = '';

        $sql = "SELECT vd.vote_id, vd.vote_text, vd.vote_start, vd.vote_length, vr.vote_option_id, vr.vote_option_text, vr.vote_result
                FROM " . VOTE_DESC_TABLE . " vd, " . VOTE_RESULTS_TABLE . " vr
                WHERE vd.topic_id = $topic_id
                        AND vr.vote_id = vd.vote_id
                ORDER BY vr.vote_option_id ASC";
        if ( !($result = $db->sql_query($sql)) )
        {
                message_die(GENERAL_ERROR, "Could not obtain vote data for this topic", '', __LINE__, __FILE__, $sql);
        }

        if ( $vote_info = $db->sql_fetchrowset($result) )
        {
                $db->sql_freeresult($result);
                $vote_options = count($vote_info);

                $vote_id = $vote_info[0]['vote_id'];
                $vote_title = $vote_info[0]['vote_text'];

                $sql = "SELECT vote_id
                        FROM " . VOTE_USERS_TABLE . "
                        WHERE vote_id = $vote_id
                                AND vote_user_id = " . intval($userdata['user_id']);
                if ( !($result = $db->sql_query($sql)) )
                {
                        message_die(GENERAL_ERROR, "Could not obtain user vote data for this topic", '', __LINE__, __FILE__, $sql);
                }

                $user_voted = ( $row = $db->sql_fetchrow($result) ) ? TRUE : 0;
                $db->sql_freeresult($result);

                if ( isset($HTTP_GET_VARS['vote']) || isset($HTTP_POST_VARS['vote']) )
                {
                        $view_result = ( ( ( isset($HTTP_GET_VARS['vote']) ) ? $HTTP_GET_VARS['vote'] : $HTTP_POST_VARS['vote'] ) == 'viewresult' ) ? TRUE : 0;
                }
                else
                {
                        $view_result = 0;
                }

                $poll_expired = ( $vote_info[0]['vote_length'] ) ? ( ( $vote_info[0]['vote_start'] + $vote_info[0]['vote_length'] < time() ) ? TRUE : 0 ) : 0;
                $sql = "SELECT pt.bbcode_uid FROM " . TOPICS_TABLE . " t, " . POSTS_TEXT_TABLE . " pt
                        WHERE t.topic_id = $topic_id
                                AND t.topic_first_post_id = pt.post_id
                        LIMIT 1";
                if (!$result = $db->sql_query($sql))
                {
                        message_die(GENERAL_ERROR, 'Could not read bbcode for poll_options', '', __LINE__, __FILE__, $sql);
                }
                $row = $db->sql_fetchrow($result);
                $bbcode_uid = $row['bbcode_uid'];
                $db->sql_freeresult($result);


                if ( $user_voted || $view_result || $poll_expired || !$is_auth['auth_vote'] || $forum_topic_data['topic_status'] == TOPIC_LOCKED )
                {
                        $template->set_filenames(array(
                                'pollbox' => 'viewtopic_poll_result.tpl')
                        );

                        $vote_results_sum = 0;

                        for($i = 0; $i < $vote_options; $i++)
                        {
                                $vote_results_sum += $vote_info[$i]['vote_result'];
                        }

                        $vote_graphic = 0;
                        $vote_graphic_max = count($images['voting_graphic']);

                        for($i = 0; $i < $vote_options; $i++)
                        {
                                $vote_percent = ( $vote_results_sum > 0 ) ? $vote_info[$i]['vote_result'] / $vote_results_sum : 0;
                                $vote_graphic_length = round($vote_percent * $board_config['vote_graphic_length']);

                                $vote_graphic_img = $images['voting_graphic'][$vote_graphic];
                                $vote_graphic = ($vote_graphic < $vote_graphic_max - 1) ? $vote_graphic + 1 : 0;

                                if ( count($orig_word) )
                                {
                                        $vote_info[$i]['vote_option_text'] = preg_replace($orig_word, $replacement_word, $vote_info[$i]['vote_option_text']);
                                }

                                        $vote_caption_text = $vote_info[$i]['vote_option_text'];
                                        $vote_caption_text = (!$board_config['allow_html']) ? preg_replace('#(<)([\/]?.*?)(>)#is', "&lt;\\2&gt;", $vote_caption_text) : $vote_caption_text;
                                        $vote_caption_text = ($board_config['allow_bbcode'] && $bbcode_uid != '') ? bbencode_second_pass($vote_caption_text, $bbcode_uid) : preg_replace('/\:[0-9a-z\:]+\]/si', ']', $vote_caption_text);
                                        $vote_caption_text = make_clickable($vote_caption_text);
                                        $vote_caption_text = ($board_config['allow_smilies']) ? smilies_pass($vote_caption_text) : $vote_caption_text;

                                        $template->assign_block_vars("poll_option", array(
                                        'POLL_OPTION_CAPTION' => $vote_caption_text,
                                        'POLL_OPTION_RESULT' => $vote_info[$i]['vote_result'],
                                        'POLL_OPTION_PERCENT' => sprintf("%.1d%%", ($vote_percent * 100)),

                                        'POLL_OPTION_IMG' => $vote_graphic_img,
                                        'POLL_OPTION_IMG_WIDTH' => $vote_graphic_length)
                                );
                        }

                        $template->assign_vars(array(
                                'L_TOTAL_VOTES' => $lang['Total_votes'],
                                'TOTAL_VOTES' => $vote_results_sum,
                                'MAX_POLL_OPTION' => 0,
                                'MAX_VOTE' => 0,

                                'L_VIEW_BALLOT' => $lang['View_ballot'],
                                'U_VIEW_BALLOT' => append_sid("viewtopic.$phpEx?". POST_TOPIC_URL ."=$topic_id&amp;postdays=$post_days&amp;postorder=$post_order"))
                        );

                        if (!$user_voted && !$poll_expired && $is_auth['auth_vote'] && ($forum_topic_data['topic_status'] != TOPIC_LOCKED))
                        {
                                $template->assign_block_vars('switch_view_ballot', array());
                        }

                }
                else
                {
                        $template->set_filenames(array(
                                'pollbox' => 'viewtopic_poll_ballot.tpl')
                        );

                        for($i = 0; $i < $vote_options; $i++)
                        {
                                if ( count($orig_word) )
                                {
                                        $vote_info[$i]['vote_option_text'] = preg_replace($orig_word, $replacement_word, $vote_info[$i]['vote_option_text']);
                                }

                                $vote_caption_text = $vote_info[$i]['vote_option_text'];
                                $vote_caption_text = (!$board_config['allow_html']) ? preg_replace('#(<)([\/]?.*?)(>)#is', "&lt;\\2&gt;", $vote_caption_text) : $vote_caption_text;
                                $vote_caption_text = ($board_config['allow_bbcode'] && $bbcode_uid != '') ? bbencode_second_pass($vote_caption_text, $bbcode_uid) : preg_replace('/\:[0-9a-z\:]+\]/si', ']', $vote_caption_text);
                                $vote_caption_text = make_clickable($vote_caption_text);
                                $vote_caption_text = ($board_config['allow_smilies']) ? smilies_pass($vote_caption_text) : $vote_caption_text;

                                $template->assign_block_vars("poll_option", array(
                                        "POLL_OPTION_ID" => $vote_info[$i]['vote_option_id'],
                                        "POLL_OPTION_CAPTION" => $vote_caption_text)
                                );
                        }

                        $template->assign_vars(array(
                                'L_SUBMIT_VOTE' => $lang['Submit_vote'],
                                'L_VIEW_RESULTS' => $lang['View_results'],
                                'L_MAX_POLL_OPTION' => $lang['Max_voting_1_explain'] . (($max_vote) ? $max_vote : 1) . $lang['Max_voting_2_explain'],

                                'MAX_VOTE' => ($max_vote) ? $max_vote : 1,
                                'MAX_POLL_OPTION' => $vote_options,
                                'U_VIEW_RESULTS' => append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;postdays=$post_days&amp;postorder=$post_order&amp;vote=viewresult"))
                        );

                        $s_hidden_fields = '<input type="hidden" name="topic_id" value="' . $topic_id . '" /><input type="hidden" name="mode" value="vote" />';
                }

                if ( count($orig_word) )
                {
                        $vote_title = preg_replace($orig_word, $replacement_word, $vote_title);
                }

                $s_hidden_fields .= '<input type="hidden" name="sid" value="' . $userdata['session_id'] . '" />';

                $template->assign_vars(array(
                        'POLL_QUESTION' => $vote_title,

                        'S_HIDDEN_FIELDS' => $s_hidden_fields,
                        'S_POLL_ACTION' => append_sid("posting.$phpEx?mode=vote&amp;" . POST_TOPIC_URL . "=$topic_id"))
                );

                $template->assign_var_from_handle('POLL_DISPLAY', 'pollbox');
        }
}

init_display_post_attachments($forum_topic_data['topic_attachment']);

//
// Update the topic view counter
//
$sql = "UPDATE " . TOPICS_TABLE . "
        SET topic_views = topic_views + 1
        WHERE topic_id = $topic_id";
if ( !$db->sql_query($sql) )
{
        message_die(GENERAL_ERROR, "Could not update topic views.", '', __LINE__, __FILE__, $sql);
}




//
// Okay, let's do the loop, yeah come on baby let's do the loop
// and it goes like this ...
//
// Start add - Birthday MOD
$this_year = create_date('Y', time(), $board_config['board_timezone']);
$this_date = create_date('md', time(), $board_config['board_timezone']);
// End add - Birthday MOD
for($i = 0; $i < $total_posts; $i++)
{

//------------------------------------------------------------------------
// Contact List - Begin Code Addition
//
        if( $postrow[$i]['user_id'] != ANONYMOUS && !defined('NO_CONTACTS') )
        {
                $contact_result = $contact_list->get_image_links($postrow[$i]['user_id'], $postrow[$i]['username'], $ignore_users);
                if( !$contact_result )
                {
                        $have_ignored = true;
                        continue;
                }
        }
//
// Contact List - End Code Addition
//------------------------------------------------------------------------



        $poster_id = $postrow[$i]['user_id'];
        $poster = ( $poster_id == ANONYMOUS ) ? $lang['Guest'] : $postrow[$i]['username'];

// Start add - Birthday MOD
        if ( $postrow[$i]['user_birthday'] != 999999 )
        {
                $poster_birthdate=realdate('md', $postrow[$i]['user_birthday']);
                $poster_age = $this_year - realdate ('Y',$postrow[$i]['user_birthday']);
                if ($this_date < $poster_birthdate) $poster_age--;
                $poster_age = $lang['Age'] . ': ' . $poster_age;
        } else
        {
                $poster_age = '';
                $poster_birthdate = '';
        }
// End add - Birthday MOD

        if ($this_date == $poster_birthdate)
        {
        $gebbild = '<img src="templates/' . $theme['template_name'] . '/images/birthdaycake.gif" border="0" alt="Happy Birthday" title="Happy Birthday">';
        }
        else
        {
        $gebbild = ' ';
        }

        $post_date = create_date($board_config['default_dateformat'], $postrow[$i]['post_time'], $board_config['board_timezone']);

        $poster_posts = ( $postrow[$i]['user_id'] != ANONYMOUS ) ? $lang['Posts'] . ': ' . $postrow[$i]['user_posts'] : '';

        $poster_from = ( $postrow[$i]['user_from'] && $postrow[$i]['user_id'] != ANONYMOUS ) ? $lang['Location'] . ': ' . $postrow[$i]['user_from'] : '';
// FLAGHACK-start
        $poster_from_flag = ( $postrow[$i]['user_from_flag'] && $postrow[$i]['user_id'] != ANONYMOUS ) ? "<img src=\"images/flags/" . $postrow[$i]['user_from_flag'] . "\" alt=\"" . $postrow[$i]['user_from_flag'] . "\" border=\"0\" width=\"32\" height=\"20\" /><br />" : "";
// FLAGHACK-end
        $poster_joined = ( $postrow[$i]['user_id'] != ANONYMOUS ) ? $lang['Joined'] . ': ' . create_date($lang['DATE_FORMAT'], $postrow[$i]['user_regdate'], $board_config['board_timezone']) : '';

        $poster_avatar = '';
        if ( $postrow[$i]['user_avatar_type'] && $poster_id != ANONYMOUS && $postrow[$i]['user_allowavatar'] )
        {
                switch( $postrow[$i]['user_avatar_type'] )
                {
                        case USER_AVATAR_UPLOAD:
                                $poster_avatar = ( $board_config['allow_avatar_upload'] ) ? '<img src="' . $board_config['avatar_path'] . '/' . $postrow[$i]['user_avatar'] . '" alt="" border="0" />' : '';
                                break;
                        case USER_AVATAR_REMOTE:
                                $poster_avatar = ( $board_config['allow_avatar_remote'] ) ? '<img src="' . $postrow[$i]['user_avatar'] . '" alt="" border="0" />' : '';
                                break;
                        case USER_AVATAR_GALLERY:
                                $poster_avatar = ( $board_config['allow_avatar_local'] ) ? '<img src="' . $board_config['avatar_gallery_path'] . '/' . $postrow[$i]['user_avatar'] . '" alt="" border="0" />' : '';
                                break;
                }
        }

        //
        // Define the little post icon
        //
        if ( $userdata['session_logged_in'] && $postrow[$i]['post_time'] > $userdata['user_lastvisit'] && $postrow[$i]['post_time'] > $topic_last_read )
        {
                $mini_post_img = $images['icon_minipost_new'];
                $mini_post_alt = $lang['New_post'];
        }
        else
        {
                $mini_post_img = $images['icon_minipost'];
                $mini_post_alt = $lang['Post'];
        }

        $mini_post_url = append_sid("viewtopic.$phpEx?" . POST_POST_URL . '=' . $postrow[$i]['post_id']) . '#' . $postrow[$i]['post_id'];

        //
        // Generate ranks, set them to empty string initially.
        //
        $poster_rank = '';
        $rank_image = '';
// Start add - Gender MOD
$gender_image = '';
// End add - Gender MOD
        if ( $postrow[$i]['user_id'] == ANONYMOUS )
        {
        }
        else if ( $postrow[$i]['user_rank'] )
        {
                for($j = 0; $j < count($ranksrow); $j++)
                {
                        if ( $postrow[$i]['user_rank'] == $ranksrow[$j]['rank_id'] && $ranksrow[$j]['rank_special'] )
                        {
                                $poster_rank = $ranksrow[$j]['rank_title'];
                                $rank_image = ( $ranksrow[$j]['rank_image'] ) ? '<img src="' . $ranksrow[$j]['rank_image'] . '" alt="' . $poster_rank . '" title="' . $poster_rank . '" border="0" /><br />' : '';
                        }
                }
        }
        else
        {
                for($j = 0; $j < count($ranksrow); $j++)
                {
                        if ( $postrow[$i]['user_posts'] >= $ranksrow[$j]['rank_min'] && !$ranksrow[$j]['rank_special'] )
                        {
                                $poster_rank = $ranksrow[$j]['rank_title'];
                                $rank_image = ( $ranksrow[$j]['rank_image'] ) ? '<img src="' . $ranksrow[$j]['rank_image'] . '" alt="' . $poster_rank . '" title="' . $poster_rank . '" border="0" /><br />' : '';
                        }
                }
        }

        //
        // Handle anon users posting with usernames
        //
        if ( $poster_id == ANONYMOUS && $postrow[$i]['post_username'] != '' )
        {
                $poster = $postrow[$i]['post_username'];
                $poster_rank = $lang['Guest'];
// Start add - Birthday MOD
                $poster_age = '';
// End add - Birthday MOD
        }

        $temp_url = '';

        if ( $poster_id != ANONYMOUS )
        {
                $temp_url = append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=$poster_id");
                $profile_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_profile'] . '" alt="' . $lang['Read_profile'] . '" title="' . $lang['Read_profile'] . '" border="0" /></a>';
                $profile = '<a href="' . $temp_url . '">' . $lang['Read_profile'] . '</a>';

                $temp_url = append_sid("privmsg.$phpEx?mode=post&amp;" . POST_USERS_URL . "=$poster_id&gesendet=fenster");
                $temp_popup = "window.open('$temp_url', 'Send_PM_Popup', 'width=600,height=500,scrollbars=yes,resizable=yes');";
                $pm_img = '<a href="javascript:void(0);" onClick="' . $temp_popup . '"><img src="' . $images['icon_pm'] . '" alt="' . $lang['Send_private_message'] . '" title="' . $lang['Send_private_message'] . '" border="0" /></a>';
                $temp_url_profile = append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=$poster_id");
                $profile_menu = '<a href="' . $temp_url_profile . '"><img src="' . $images['menu_profile'] . '" border="0" />&nbsp;' . $lang['Read_profile_menu'] . '</a>';
                $temp_url_menu = append_sid("privmsg.$phpEx?mode=post&amp;" . POST_USERS_URL . "=$poster_id");
                $pm_menu = '<a href="' . $temp_url_menu . '"><img src="' . $images['menu_pm'] . '" border="0" />&nbsp;' . $lang['Send_private_message_menu'] . '</a>';
                $posts_menu = '<a href="search.php?show_results=posts&amp;search_author=' . $poster . '"><img src="' . $images['menu_posts'] . '" border="0" />&nbsp;' . $lang['Search_user_posts_menu'] . '</a>';
                $user_album_pics_menu = '<a href="album.php?user_id=' . $poster_id . '&mode=list"><img src="' . $images['menu_pics'] . '" border="0" />&nbsp;' . $lang['user_album_pics_menu'] . '</a>';
                $www_menu = ( $postrow[$i]['user_website'] ) ? '<a href="' . $postrow[$i]['user_website'] . '" target="_userwww"><img src="' . $images['menu_web'] . '" border="0" />&nbsp;' . $lang['Visit_website'] . '</a>' : '';
                $menu_id = append_sid($poster_id);

// Start add - Gender MOD
switch ($postrow[$i]['user_gender'])
{
   case 1 : $gender_image = $lang['Gender'].": <img src=" . $images['icon_minigender_male'] . ">"; break;
   case 2 : $gender_image = $lang['Gender'].": <img src=" . $images['icon_minigender_female'] . ">"; break;
   default : $gender_image="";
}
// End add - Gender MOD
                $pm = '<a href="' . $temp_url . '">' . $lang['Send_private_message'] . '</a>';

 // Photo Album Link MOD - Daz - ForumImages.com - START
      $temp_url = append_sid("album.$phpEx?user_id=$poster_id");
      $gallery_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_gallery'] . '" alt="' . sprintf($lang['Personal_Gallery_Of_User'], $postrow[$i]['username']) . '" title="' . sprintf($lang['Personal_Gallery_Of_User'], $postrow[$i]['username']) . '" border="0" /></a>';
      $gallery = '<a href="' . $temp_url . '">' . $lang['Album'] . '</a>';
      // Photo Album Link MOD - Daz - ForumImages.com - END


                if ( !empty($postrow[$i]['user_viewemail']) || $is_auth['auth_mod'] )
                {
                        $email_uri = ( $board_config['board_email_form'] ) ? append_sid("profile.$phpEx?mode=email&amp;" . POST_USERS_URL .'=' . $poster_id) : 'mailto:' . $postrow[$i]['user_email'];

                        $email_img = '<a href="' . $email_uri . '"><img src="' . $images['icon_email'] . '" alt="' . $lang['Send_email'] . '" title="' . $lang['Send_email'] . '" border="0" /></a>';
                        $email = '<a href="' . $email_uri . '">' . $lang['Send_email'] . '</a>';
                        $email_menu = '<a href="' . $email_uri . '"><img src="' . $images['menu_mail'] . '" border="0" />&nbsp;' . $lang['Send_email_menu'] . '</a>';
                }
                else
                {
                        $email_img = '';
                        $email = '';
                }

                $www_img = ( $postrow[$i]['user_website'] ) ? '<a href="' . $postrow[$i]['user_website'] . '" target="_userwww"><img src="' . $images['icon_www'] . '" alt="' . $lang['Visit_website'] . '" title="' . $lang['Visit_website'] . '" border="0" /></a>' : '';
                $www = ( $postrow[$i]['user_website'] ) ? '<a href="' . $postrow[$i]['user_website'] . '" target="_userwww">' . $lang['Visit_website'] . '</a>' : '';

                if ( !empty($postrow[$i]['user_icq']) )
                {
                        $icq_status_img = '<a href="http://wwp.icq.com/' . $postrow[$i]['user_icq'] . '#pager"><img src="http://web.icq.com/whitepages/online?icq=' . $postrow[$i]['user_icq'] . '&img=5" width="18" height="18" border="0" /></a>';
                        $temp_icq_url = append_sid('icqinfo.php?info=' . $postrow[$i]['user_icq']);
                        $temp_icq_popup = "Javascript:window.open('$temp_icq_url', '_icqinfo_popup', 'width=400,height=320,scrollbars=yes');";
                        $icq_img = '<a href="javascript:void(0);" onClick="' . $temp_icq_popup . '"><img src="' . $images['icon_icq'] . '" alt="' . $lang['ICQ'] . '" title="' . $lang['ICQ'] . '" border="0" /></a>';
                        $icq =  '<a href="http://wwp.icq.com/scripts/search.dll?to=' . $postrow[$i]['user_icq'] . '">' . $lang['ICQ'] . '</a>';
                }
                else
                {
                        $icq_status_img = '';
                        $icq_img = '';
                        $icq = '';
                }

                $aim_img = ( $postrow[$i]['user_aim'] ) ? '<a href="aim:goim?screenname=' . $postrow[$i]['user_aim'] . '&amp;message=Hello+Are+you+there?"><img src="' . $images['icon_aim'] . '" alt="' . $lang['AIM'] . '" title="' . $lang['AIM'] . '" border="0" /></a>' : '';
                $aim = ( $postrow[$i]['user_aim'] ) ? '<a href="aim:goim?screenname=' . $postrow[$i]['user_aim'] . '&amp;message=Hello+Are+you+there?">' . $lang['AIM'] . '</a>' : '';

                $temp_url = append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=$poster_id");
                $msn_img = ( $postrow[$i]['user_msnm'] ) ? '<a href="' . $temp_url . '"><img src="' . $images['icon_msnm'] . '" alt="' . $lang['MSNM'] . '" title="' . $lang['MSNM'] . '" border="0" /></a>' : '';
                $msn = ( $postrow[$i]['user_msnm'] ) ? '<a href="' . $temp_url . '">' . $lang['MSNM'] . '</a>' : '';

                $yim_img = ( $postrow[$i]['user_yim'] ) ? '<a href="http://edit.yahoo.com/config/send_webmesg?.target=' . $postrow[$i]['user_yim'] . '&amp;.src=pg"><img src="' . $images['icon_yim'] . '" alt="' . $lang['YIM'] . '" title="' . $lang['YIM'] . '" border="0" /></a>' : '';
                $yim = ( $postrow[$i]['user_yim'] ) ? '<a href="http://edit.yahoo.com/config/send_webmesg?.target=' . $postrow[$i]['user_yim'] . '&amp;.src=pg">' . $lang['YIM'] . '</a>' : '';

                $skype_img = ( $postrow[$i]['user_skype'] ) ? '<a href="callto://' . $postrow[$i]['user_skype'] . '/"><img src="' . $images['icon_skype'] . '" alt="' . $lang['SKYPE'] . '" title="' . $lang['SKYPE'] . '" border="0" /></a>' : '';
                $skype = ( $postrow[$i]['user_skype'] ) ? '<a href="callto://' . $postrow[$i]['user_skype'] . '/">' . $lang['SKYPE'] . '</a>' : '';
        }
        else
        {
                $profile_img = '';
                $profile = '';
                $pm_img = '';
                $pm = '';
                // Photo Album Link MOD - Daz - ForumImages.com - START
      $gallery_img = '';
      $gallery = '';
      // Photo Album Link MOD - Daz - ForumImages.com - END
                $email_img = '';
                $email = '';
                $www_img = '';
                $www = '';
                $icq_status_img = '';
                $icq_img = '';
                $icq = '';
                $aim_img = '';
                $aim = '';
                $msn_img = '';
                $msn = '';
                $yim_img = '';
                $yim = '';
                $skype_img = '';
                $skype = '';
        }

        $temp_url = append_sid("posting.$phpEx?mode=quote&amp;" . POST_POST_URL . "=" . $postrow[$i]['post_id']);
        $quote_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_quote'] . '" alt="' . $lang['Reply_with_quote'] . '" title="' . $lang['Reply_with_quote'] . '" border="0" /></a>';
        $quote = '<a href="' . $temp_url . '">' . $lang['Reply_with_quote'] . '</a>';

        $temp_url = append_sid("search.$phpEx?search_author=" . urlencode($postrow[$i]['username']) . "&amp;showresults=posts");
        $search_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_search'] . '" alt="' . sprintf($lang['Search_user_posts'], $postrow[$i]['username']) . '" title="' . sprintf($lang['Search_user_posts'], $postrow[$i]['username']) . '" border="0" /></a>';
        $search = '<a href="' . $temp_url . '">' . sprintf($lang['Search_user_posts'], $postrow[$i]['username']) . '</a>';

        //MOD-REPLACE: Remove Users Signature & Editing Privileges ----------------------------------------
        //added: $userdata['user_allowedit'] && (  .... )
        if ( $userdata['user_allowedit'] && ( $userdata['user_id'] == $poster_id && $is_auth['auth_edit'] && ($forum_topic_data['topic_status'] != TOPIC_LOCKED)) || $is_auth['auth_mod'] )
        {
                $edit_url = append_sid("posting.$phpEx?mode=editpost&amp;" . POST_POST_URL . "=" . $postrow[$i]['post_id']);
                $edit_img = '<a href="'. $edit_url .'"><img src="' . $images['icon_edit'] . '" alt="' . $lang['Edit_delete_post'] . '" title="' . $lang['Edit_delete_post'] . '" border="0" /></a>';
                $edit = '<a id="editlink_'. $postrow[$i]['post_id'] .'" onclick="return AJAXPostEdit('. $postrow[$i]['post_id'] .');" href="' . $edit_url . '" style="text-decoration: none;">[ ' . $lang['Edit_quick_post'] . ' ]</a>';

        }
        else
        {
                $edit_img = '';

                $edit = '';
                $edit_url = '';
        }

        if ( $is_auth['auth_mod'] )
        {
                $temp_url = "modcp.$phpEx?mode=ip&amp;" . POST_POST_URL . "=" . $postrow[$i]['post_id'] . "&amp;" . POST_TOPIC_URL . "=" . $topic_id . "&amp;sid=" . $userdata['session_id'];
                $ip_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_ip'] . '" alt="' . $lang['View_IP'] . '" title="' . $lang['View_IP'] . '" border="0" /></a>';
                $ip = '<a href="' . $temp_url . '">' . $lang['View_IP'] . '</a>';

                $temp_url = "posting.$phpEx?mode=delete&amp;" . POST_POST_URL . "=" . $postrow[$i]['post_id'] . "&amp;sid=" . $userdata['session_id'];
                $delpost_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_delpost'] . '" alt="' . $lang['Delete_post'] . '" title="' . $lang['Delete_post'] . '" border="0" /></a>';
                $delpost = '<a href="' . $temp_url . '">' . $lang['Delete_post'] . '</a>';
        }
        else
        {
                $ip_img = '';
                $ip = '';

                if ( $userdata['user_id'] == $poster_id && $is_auth['auth_delete'] && $forum_topic_data['topic_last_post_id'] == $postrow[$i]['post_id'] )
                {
                        $temp_url = "posting.$phpEx?mode=delete&amp;" . POST_POST_URL . "=" . $postrow[$i]['post_id'] . "&amp;sid=" . $userdata['session_id'];
                        $delpost_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_delpost'] . '" alt="' . $lang['Delete_post'] . '" title="' . $lang['Delete_post'] . '" border="0" /></a>';
                        $delpost = '<a href="' . $temp_url . '">' . $lang['Delete_post'] . '</a>';
                }
                else
                {
                        $delpost_img = '';
                        $delpost = '';
                }
        }
// BEGIN Report Post Hack
        $temp_url = append_sid("report.$phpEx?mode=report&amp;" . POST_POST_URL . "=" . $postrow[$i]['post_id'] . (isset($HTTP_GET_VARS['return_to_list']) ? '&amp;return_to_list' : ''));
        $report_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_report_' . intval($postrow[$i]['post_report'])] . '" alt="' . $lang['Report_post'] . '" title="' . $lang['Report_post'] . '" border="0" /></a>';
        $report = '<a href="' . $temp_url . '">' . $lang['Report_post'] . '</a>';
        if ( $is_auth['auth_mod'] && (!$board_config['report_only_admin'] || $userdata['userlevel'] == ADMIN) )
        {
                if ( $postrow[$i]['post_report'] == 2 )
                {
                        $temp_url = append_sid("report.$phpEx?mode=unlock&amp;" . POST_POST_URL . "=" . $postrow[$i]['post_id']);
                        $report_img .= ' <a href="' . $temp_url . '"><img src="' . $images['icon_unlock_report'] . '" alt="' . $lang['Report_unlock'] . '" title="' . $lang['Report_unlock'] . '" border="0" /></a>';
                        $report .= ' <a href="' . $temp_url . '">' . $lang['Report_unlock'] . '</a>';
                }
                else
                {
                        $temp_url = append_sid("report.$phpEx?mode=lock&amp;" . POST_POST_URL . "=" . $postrow[$i]['post_id']);
                        $report_img .= ' <a href="' . $temp_url . '"><img src="' . $images['icon_lock_report'] . '" alt="' . $lang['Report_lock'] . '" title="' . $lang['Report_lock'] . '" border="0" /></a>';
                        $report .= ' <a href="' . $temp_url . '">' . $lang['Report_lock'] . '</a>';
                }
        }
        // END Report Post Hack
        
        
        $post_subject = ( $postrow[$i]['post_subject'] != '' ) ? $postrow[$i]['post_subject'] : '';
        $post_ajax_raw_subject = $post_subject;
                // CrackerTracker v5.x
        if ( $postrow[$i]['ct_miserable_user'] == 1 && $postrow[$i]['user_id'] != $userdata['user_id'] && $userdata['user_level'] == 0)
        {
                $message = $lang['ctracker_message_dialog_title'] . '<br /><br />' . $lang['ctracker_ipb_deleted'];
        }
        else
        {
                // Cache Posts
	$parsed = ($board_config['enable_post_cache']) ? $postrow[$i]['parsed'] : 0;
	if (!$parsed || !$board_config['enable_post_cache'])
	{
		$message = $postrow[$i]['post_text'];
	} else {
		$cstyle = ($userdata['session_logged_in'] && $userdata['user_style'] != $board_config['default_style'] && $board_config['cache_each_template']) ? $userdata['user_style'].'_' : '';
		$cachefile = 'cache/posts/'.$cstyle.'post_'.$postrow[$i]['post_id'].'.gz';
		if (file_exists($cachefile) && filemtime($cachefile) >= $postrow[$i]['post_edit_time'] && $postrow[$i]['cache_file_md5'] == md5_file($cachefile))
		{
			$handle = @fopen($phpbb_root_path.$cachefile, 'r');
			$message = gzinflate(@fread($handle, @filesize($cachefile)+1));
			@fclose($handle);
		} else {
			@unlink($cachefile);
			$message = $postrow[$i]['post_text'];
			$parsed = 0;
		}
	}
// Cache Posts
//	$message = $postrow[$i]['post_text'];


                if ( $postrow[$i]['ct_miserable_user'] == 1 && $userdata['user_level'] == ADMIN )
                {
                        $message .= '<br /><br />' . $lang['ctracker_mu_success'];
                }
        }

        $bbcode_uid = $postrow[$i]['bbcode_uid'];

        //MOD-REPLACE: Remove Users Signature & Editing Privileges ----------------------------------------
        //added: && $postrow[$i]['user_allowsig']
        
        $user_sig = ( $postrow[$i]['enable_sig'] && $postrow[$i]['user_sig'] != '' && $board_config['allow_sig'] && $postrow[$i]['user_allowsig'] ) ? $postrow[$i]['user_sig'] : '';
        $user_sig_bbcode_uid = $postrow[$i]['user_sig_bbcode_uid'];

        //
        // Note! The order used for parsing the message _is_ important, moving things around could break any
        // output
        //

        //
        // If the board has HTML off but the post has HTML
        // on then we process it, else leave it alone
        //
    if ( !$board_config['allow_html'] || !$userdata['user_allowhtml'])
        {
                if ( $user_sig != '' )
                {
                        $user_sig = preg_replace('#(<)([\/]?.*?)(>)#is', "&lt;\\2&gt;", $user_sig);
                }

                		// Cache Posts
		if (!$parsed || !$board_config['enable_post_cache'])
		{
			if ( $postrow[$i]['enable_html'] )
			{
				$message = preg_replace('#(<)([\/]?.*?)(>)#is', "&lt;\\2&gt;", $message);
			}
		}
		// Cache Posts
/*		if ( $postrow[$i]['enable_html'] )
		{
			$message = preg_replace('#(<)([\/]?.*?)(>)#is', "&lt;\\2&gt;", $message);
		}*/


                {
                        $message = preg_replace('#(<)([\/]?.*?)(>)#is', "&lt;\\2&gt;", $message);
                }
        }

        //
        // Parse message and/or sig for BBCode if reqd
        //
        if ($user_sig != '' && $user_sig_bbcode_uid != '')
        {
                $user_sig = ($board_config['allow_bbcode']) ? bbencode_second_pass($user_sig, $user_sig_bbcode_uid) : preg_replace("/\:$user_sig_bbcode_uid/si", '', $user_sig);
        }

 		// Cache Posts
		if (!$parsed || !$board_config['enable_post_cache'])
		{
			if ( $bbcode_uid != '' )
			{
				$message = ($board_config['allow_bbcode']) ? bbencode_second_pass($message, $bbcode_uid) : preg_replace("/\:$bbcode_uid/si", '', $message);
			}
		}
		// Cache Posts
/*		if ( $bbcode_uid != '' )
		{
			$message = ($board_config['allow_bbcode']) ? bbencode_second_pass($message, $bbcode_uid) : preg_replace("/\:$bbcode_uid/si", '', $message);
		}*/

        if ( $user_sig != '' )
        {
                $user_sig = make_clickable($user_sig);
        }
        	(!$parsed || !$board_config['enable_post_cache']) ? $message = make_clickable($message) : ''; // Cache Posts
//	$message = make_clickable($message);


        // BEGIN CMX News Mod
        // Strip out the <!--break--> delimiter.
        $delim = htmlspecialchars( '<!--break-->' );
        $pos = strpos( $message, $delim );
        if( ($pos !== false) && ($pos < strlen( $message )) ) {
                $message = substr_replace( $message, html_entity_decode($delim), $pos, strlen($delim) );
        }
        // END CMX News Mod


        //
        // Parse smilies
        //
        if ( $board_config['allow_smilies'] )
        {
                if ( $postrow[$i]['user_allowsmile'] && $user_sig != '' )
                {
                        $user_sig = smilies_pass($user_sig);
                }

 		(!$parsed || !$board_config['enable_post_cache']) ? (($postrow[$i]['enable_smilies']) ? $message = smilies_pass($message) : '') : ''; // Cache Posts
/*		if ( $postrow[$i]['enable_smilies'] )
		{
			$message = smilies_pass($message);
		}*/

        }


// Cache Posts
	if (!$parsed && $board_config['enable_post_cache'] && ($postrow[$i]['enable_bbcode'] || $postrow[$i]['enable_html']) && !$postrow[$i]['dont_cache'] && !$forum_topic_data['topic_cache_lock'])
	{
		$cstyle = ($userdata['session_logged_in'] && $userdata['user_style'] != $board_config['default_style'] && $board_config['cache_each_template']) ? $userdata['user_style'].'_' : '';
		$cachefile = 'cache/posts/'.$cstyle.'post_'.$postrow[$i]['post_id'].'.gz';
		$handle = @fopen($phpbb_root_path.$cachefile, 'w');
		@flock($handle, LOCK_EX);
		$packed = gzdeflate($message, 9);
		$cf_size = @fwrite($handle, $packed);
		@flock($handle, LOCK_UN);
		@fclose($handle);
		@chmod($phpbb_root_path.$cachefile, 0666);

		if ($cf_size)
		{
			if ($cf_size > $board_config['min_post_cache_size'])
			{
				$parsed = 1;
				$sql = "UPDATE " . POSTS_TABLE . "
					SET parsed = 1, cache_file_md5 = '".md5_file($cachefile)."'
					WHERE post_id = ".$postrow[$i]['post_id'];
				if(!$result = $db->sql_query($sql))
				{
					message_die(GENERAL_ERROR, 'Could not update parse info', '', __LINE__, __FILE__, $sql);
				}
			}
			else
			{
				$parsed = 0;
				$postrow[$i]['dont_cache'] = 1;
				foreach (glob($phpbb_root_path.'cache/posts/*post_'.$postrow[$i]['post_id'].'.gz') as $cachefile)
				{
					@unlink($cachefile);
				}
				$sql = "UPDATE " . POSTS_TABLE . "
					SET parsed = 0, dont_cache = 1, cache_file_md5 = NULL
					WHERE post_id = ".$postrow[$i]['post_id'];
				if(!$result = $db->sql_query($sql))
				{
					message_die(GENERAL_ERROR, 'Could not update parse info', '', __LINE__, __FILE__, $sql);
				}
			}
		}
		else if ($postrow[$i]['parsed'])
		{
			$parsed = 0;
			$sql = "UPDATE " . POSTS_TABLE . "
				SET parsed = 0, cache_file_md5 = NULL
				WHERE post_id = ".$postrow[$i]['post_id'];
			if(!$result = $db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, 'Could not update parse info', '', __LINE__, __FILE__, $sql);
			}
		}
		$postrow[$i]['parsed'] = $parsed;
	}
	else if ( $forum_topic_data['topic_cache_lock'] )
	{
		$parsed = 0;
		$postrow[$i]['dont_cache'] = 1;
		$sql = "UPDATE " . POSTS_TABLE . "
			SET parsed = 0, dont_cache = 1, cache_file_md5 = NULL
			WHERE post_id = ".$postrow[$i]['post_id'];
		if(!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, 'Could not update parse info', '', __LINE__, __FILE__, $sql);
		}
		$postrow[$i]['parsed'] = $parsed;
	}
	if ($board_config['enable_post_cache'])
	{
		$parse_status = ($parsed) ? $CPS_Indicator['cached'] : (($postrow[$i]['dont_cache']) ? $CPS_Indicator['dont_cache'] : ((!$postrow[$i]['enable_bbcode'] && !$postrow[$i]['enable_html']) ? $CPS_Indicator['not_cached'] : $CPS_Indicator['error']));
		$cps_img = (!$forum_topic_data['topic_cache_lock']) ? '<a href="modcp.'.$phpEx.'?'.POST_CPS_MANAGE_URL.'=recycle&amp;'.POST_POST_URL.'='.$postrow[$i]['post_id'].'&amp;'.POST_TOPIC_URL.'='.$postrow[$i]['topic_id'].'&amp;sid='.$userdata['session_id'].'"><img src="'.$images['icon_cache_recycle'].'" alt="'.$lang['CPS_recycle'].'" title="'.$lang['CPS_recycle'].'" border="0" /></a>' : '';
		$cps_img .= ($parsed) ? ' <a href="modcp.'.$phpEx.'?'.POST_CPS_MANAGE_URL.'=deactivate&amp;'.POST_POST_URL.'='.$postrow[$i]['post_id'].'&amp;'.POST_TOPIC_URL.'='.$postrow[$i]['topic_id'].'&amp;sid='.$userdata['session_id'].'"><img src="'.$images['icon_cache_deactivate'].'" alt="'.$lang['CPS_dont_cache'].'" title="'.$lang['CPS_dont_cache'].'" border="0" /></a>' : '';
	} else {
		$parse_status = ($postrow[$i]['parsed']) ? $CPS_Indicator['off_but_cached'] : $CPS_Indicator['off'] ;
		$cps_img = ($postrow[$i]['parsed'] && $userdata['user_level'] == ADMIN) ? '<a href="modcp.'.$phpEx.'?'.POST_CPS_MANAGE_URL.'=delete&amp;'.POST_POST_URL.'='.$postrow[$i]['post_id'].'&amp;'.POST_TOPIC_URL.'='.$postrow[$i]['topic_id'].'&amp;sid='.$userdata['session_id'].'"><img src="'.$images['icon_cache_delete'].'" alt="'.$lang['CPS_delete'].'" title="'.$lang['CPS_delete'].'" border="0" /></a>' : '';
	}
// Cache Posts

        //
        // Highlight active words (primarily for search)
        //
        if ($highlight_match)
        {
                // This has been back-ported from 3.0 CVS
                $message = preg_replace('#(?!<.*)(?<!\w)(' . $highlight_match . ')(?!\w|[^<>]*>)#i', '<b style="color:#'.$theme['fontcolor3'].'">\1</b>', $message);
        }

        //
        // Replace naughty words
        //
        if (count($orig_word))
        {
                $post_subject = preg_replace($orig_word, $replacement_word, $post_subject);
                $post_ajax_raw_subject = preg_replace($orig_word, $replacement_word, $post_ajax_raw_subject);
                if ($user_sig != '')
                {
                        $user_sig = str_replace('\"', '"', substr(@preg_replace('#(\>(((?>([^><]+|(?R)))*)\<))#se', "@preg_replace(\$orig_word, \$replacement_word, '\\0')", '>' . $user_sig . '<'), 1, -1));
                }

                $message = str_replace('\"', '"', substr(preg_replace('#(\>(((?>([^><]+|(?R)))*)\<))#se', "preg_replace(\$orig_word, \$replacement_word, '\\0')", '>' . $message . '<'), 1, -1));
        }

        //
        // Replace newlines (we use this rather than nl2br because
        // till recently it wasn't XHTML compliant)
        //
        if ( $user_sig != '' )
        {
                $user_sig = '<br />_________________<br />' . str_replace("\n", "\n<br />\n", $user_sig);
        }

        $message = acronym_pass( $message );
        $message = str_replace("\n", "\n<br />\n", $message);

        //
        // Editing information
        //
            if ( $postrow[$i]['post_edit_count'] )
        {
                $l_edit_time_total = ( $postrow[$i]['post_edit_count'] == 1 ) ? $lang['Edited_time_total'] : $lang['Edited_times_total'];

                $l_edited_by = '<br /><br />' . sprintf($l_edit_time_total, $poster, create_date($board_config['default_dateformat'], $postrow[$i]['post_edit_time'], $board_config['board_timezone']), $postrow[$i]['post_edit_count']);
        }
        else
        {
                $l_edited_by = '';
        }

        if ( $postrow[$i]['user_absence'] == TRUE )
        {
                $absence_mode = create_absence_mode($postrow[$i]['user_absence_mode'], $pm_img, $pm, $email_img, $email, $poster);
        }
        

        //
        // Again this will be handled by the templating
        // code at some point
        //
        $row_color = ( !($i % 2) ) ? $theme['td_color1'] : $theme['td_color2'];
        $row_class = ( !($i % 2) ) ? $theme['td_class1'] : $theme['td_class2'];

        $is_firstpost = ($postrow[$i]['post_id'] == $forum_topic_data['topic_first_post_id']) ? 1 : 0;
        if ($can_edit = ($is_auth['auth_mod'] || (($postrow[$i]['user_id'] == $userdata['user_id'] && ($forum_topic_data['topic_status'] != TOPIC_LOCKED)) && $is_auth['auth_edit'])))
        {
                $raw_message = $postrow[$i]['post_text'];
                if (!empty($bbcode_uid))
                {
                        $raw_message = preg_replace('#\:(([a-z0-9]:)?)'. $bbcode_uid .'#s', '', $raw_message);
                }

                $raw_message = str_replace('<', '&lt;', $raw_message);
                $raw_message = str_replace('>', '&gt;', $raw_message);
                $raw_message = str_replace('<br />', "\n", $raw_message);
        }


        //Online/Offline
        if (($postrow[$i]['user_session_time'] >= ( time() - 300 )) && ($postrow[$i]['user_allow_viewonline']))
        {
                $on_off_hidden = '<img src="' . $images['icon_online'] . '" alt="' . $lang['Online'] . '" title="' . $lang['Online'] . '" border="0" />';
        }
        else if (($postrow[$i]['user_allow_viewonline']) == 0)
        {
                $on_off_hidden = '<img src="' . $images['icon_hidden'] . '" alt="' . $lang['Hidden'] . '" title="' . $lang['Hidden'] . '" border="0" />';
        }
        else if ($poster_id == ANONYMOUS)
        {
                $on_off_hidden = '';
        }
        else
        {
                $on_off_hidden = '<img src="' . $images['icon_offline'] . '" alt="' . $lang['Offline'] . '" title="' . $lang['Offline'] . '" border="0" />';
        }

 //
// BEGIN CONTEST
//

++$mcont;

if(($mcont == 1) && $is_auth['auth_contest'])
{

// ------------------------------------
// Viewing contest
// ------------------------------------

include($phpbb_root_path . 'album_mod/album_contest.'.$phpEx);
}

//
// END CONTEST
//

        if ( $userdata['user_id'] == ANONYMOUS )
        {
                $poster_joined = '';
                $poster_posts = '';
                $poster_from = '';
                  $profile_img = '';
                $profile = '';
                $search_img = '';
                $search = '';
                $pm_img = '';
                $pm = '';
                $email_img = '';
                $email = '';
                $www_img = '';
                $www = '';
                $icq_status_img = '';
                $icq_img = '';
                $icq = '';
                $aim_img = '';
                $aim = '';
                $msn_img = '';
                $msn = '';
                $yim_img = '';
                $yim = '';
                $poster_from_flag = '';
                $on_off_hidden = '';
                $poster_age = '';
                $gender_image = '';
                $quote_img = '';
                $quote = '';
                $gallery_img = '';
                $gallery = '';
        }



        $template->assign_block_vars('postrow', array(
                'DOWNLOAD_POST' => append_sid("viewtopic.$phpEx?download=".$postrow[$i]['post_id']."&amp;".POST_TOPIC_URL."=".$topic_id),
                'ROW_COLOR' => '#' . $row_color,
                'ROW_CLASS' => $row_class,
                'POSTER_NAME' => $poster,
// Start add - Birthday MOD
                'POSTER_AGE' => $poster_age,
                'GEB_BILD' => $gebbild,
// End add - Birthday MOD
                'POSTER_RANK' => $poster_rank,
// Start add - Gender MOD
'POSTER_GENDER' => $gender_image,
// End add - Gender MOD
                'RANK_IMAGE' => $rank_image,
                'POSTER_JOINED' => $poster_joined,

                'POSTER_POSTS' => $poster_posts,
                'POSTER_FROM' => $poster_from,
// FLAGHACK-start
                'POSTER_FROM_FLAG' => $poster_from_flag,
// FLAGHACK-end
                'POSTER_AVATAR' => $poster_avatar,
                'POSTER_ONLINE' => $on_off_hidden,
                'POST_DATE' => $post_date,
                'POST_SUBJECT' => (empty($post_subject)) ? $lang['No_subject'] : $post_subject,
                'POST_RAW_SUBJECT' => $post_ajax_raw_subject,

                'MESSAGE' => $message,
                'SIGNATURE' => $user_sig,
                'EDITED_MESSAGE' => $l_edited_by,
                'OPTIONS_MENU' => $lang['options_menu'],
                'PROFILE_MENU' => $profile_menu,
                'EMAIL_MENU' => $email_menu,
                'PM_MENU' => $pm_menu,
                'WWW_MENU' => $www_menu,
                'POSTS_MENU' => $posts_menu,
                'UPLOADED_PICTURES_MENU' => $user_album_pics_menu,
                'MENU_ID' => $menu_id,

                'MINI_POST_IMG' => $mini_post_img,
                'PROFILE_IMG' => $profile_img,
                'PROFILE' => $profile,
                'SEARCH_IMG' => $search_img,
                'SEARCH' => $search,
                'PM_IMG' => $pm_img,
                'PM' => $pm,
                // Photo Album Link MOD - Daz - ForumImages.com - START
      'GALLERY_IMG' => $gallery_img,
      'GALLERY' => $gallery,
      // Photo Album Link MOD - Daz - ForumImages.com - END
                'EMAIL_IMG' => $email_img,
                'EMAIL' => $email,
                'WWW_IMG' => $www_img,
                'WWW' => $www,
                'ICQ_STATUS_IMG' => $icq_status_img,
                'ICQ_IMG' => $icq_img,
                'ICQ' => $icq,
                'AIM_IMG' => $aim_img,
                'AIM' => $aim,
                'MSN_IMG' => $msn_img,
                'MSN' => $msn,
                'YIM_IMG' => $yim_img,
                'YIM' => $yim,
                'SKYPE_IMG' => $skype_img,
                'SKYPE' => $skype,
                'EDIT_IMG' => $edit_img,
                'EDIT' => $edit,
                'QUOTE_IMG' => $quote_img,
                'QUOTE' => $quote,
                'IP_IMG' => $ip_img,
                'IP' => $ip,
                'DELETE_IMG' => $delpost_img,
                'DELETE' => $delpost,
		// Cache Posts
		'CPS_STATUS' => $parse_status,
		'CPS_IMG' => ($is_auth['auth_mod'] && $board_config['allow_cache_moderate'] || $userdata['user_level'] == ADMIN) ? $cps_img : '',
		// Cache Posts

                'RAW_MESSAGE' => ($can_edit) ? $raw_message : '',
                // BEGIN Report Post Hack
                'REPORT_IMG' => $report_img,
                'REPORT' => $report,
                // END Report Post Hack
                'L_GENDER' => $lang['Gender'],
                'EDIT_HERE' => $edit,

                'L_MINI_POST_ALT' => $mini_post_alt,
                'S_FIRST_POST' => $is_firstpost,
                'S_AJAX_EDIT_TITLE' => ($can_edit) ? 'ondblclick="AJAXTitleEdit('. $postrow[$i]['post_id'] .', '. $is_firstpost .');"' : '',

                'U_EDIT_POST' => $edit_url,


                'U_MINI_POST' => $mini_post_url,
                'U_POST_ID' => $postrow[$i]['post_id'])

        );
        


        
        //begin map MOD
        if (($poster_from != '') && ((float)$postrow[$i]['longitude'] != 0)) {
                $template->assign_block_vars('postrow.switch_map', array(
                        'U_MAP'        => append_sid("map.$phpEx?highlight=".$postrow[$i]['user_id'])
                ));
        }
        else {
                $template->assign_block_vars('postrow.switch_no_map', array());
        }
//end map MOD
        
  //
        //
        //Nickpagebutton
        //
        $sql = "SELECT COUNT(uid) AS zaehle FROM ".NICKPAGE_TABLE." WHERE uid='".$poster_id."'";
        if ( !($result = $db->sql_query($sql)) )
        {
                message_die(GENERAL_ERROR, 'Querrie-Fehler', '', __LINE__, __FILE__, $sql);
        }
        $row = $db->sql_fetchrow($result);
        if($row['zaehle'] == "1")
        {
                $template->assign_block_vars('postrow.Nickpagebutton', array(
                'U_NICKPAGE' => append_sid('nickpage.'.$phpEx.'?user='.$poster),
                ));
        }

        
        display_post_attachments($postrow[$i]['post_id'], $postrow[$i]['post_attachment']);

if ($can_edit)
        {
                $template->assign_block_vars('postrow.can_edit', array());
        }

}

include($phpbb_root_path . 'quick_reply.'.$phpEx);
include($phpbb_root_path .'recent2.'.$phpEx);



$template->pparse('body');

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>